/* rcode.h - error code definitions */

/* naming convention:
E_() = Error
RN_() = Receive Notification
S_() = State
HDLC_() = HDLC-related
*/

#define	HDLC_LINK_CLOSED	0x03

#define	E_INVALID_COMMAND	0x05
#define	RN_UNNUMBERED_FRAME	0x06
#define	S_FRAME_REJECT_MODE	0x07
#define	S_MODEM_FAILURE		0x08
#define	S_N2_RETRY_EXCEEDED	0x09
#define	S_Z80_TIMEOUT		0x0a
#define	RN_ASYNC_PACKET		0x40


#define ASE_CLEAR_RQST		0x02
#define ASE_RESET_RQST		0x04
#define ASE_RESTART_RQST	0x08
#define ASE_INTERRUPT		0x10
#define ASE_DTE_REGISTR_RQST	0x20
#define ASE_CALL_RQST		0x30
#define ASE_CALL_ACCEPTED	0x31
#define ASE_CLEAR_CONFRM	0x32
#define ASE_RESET_CONFRM	0x33
#define ASE_RESTART_CONFRM	0x34
#define ASE_INTERRUPT_CONFRM	0x35
#define ASE_DCE_REGISTR_CONFRM	0x36
#define ASE_DIAGNOSTIC		0x37
#define ASE_CALL_AUTO_CLEAR	0x38
#define AUTO_RESPONSE_FLAG	0x80
#define	AUTO_RESPONSE_NOTMASK	0x7f

#define	S_PROTOCOL_VIOLATION	0x41
#define	S_TIMEOUT		0x42
#define	TIMEOUT_RESTART		0x03
#define	TIMEOUT_CALL		0x05
#define	TIMEOUT_CLEAR		0x08
#define	TIMEOUT_RESET		0x0a

#define	S_NOT_IN_ABM		0x02
#define	S_ASYNC_BUFF_IN_USE	0x33
#define	S_QUEUED_DATA		0x35
#define	S_NET_OUT_OF_ORDER	0x34
#define	S_RETRY				0x43

#define	COMMONMSG_0x31	"Specified logical channel not in data transfer state"
#define	COMMONMSG_0x35	"Queued data on specified channel"
#define	COMMONMSG_0x30	"Specified logical channel not configured"

