/* rcode.c - Result code decoder */
/* Copyright (c) 1995 Sangoma Technologies Inc.
   Author: Glenn Robins
   v0.5 beta

   This source is undocumented and unsupported. Use at your own risk.
*/

#define MAKEFORNT
#define	STRICT

#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <stdio.h>

#ifdef MAKEFORNT
#include "..\include\xapi32mc.h"
#else
#include "..\include\xapi_f.h"
#endif

#include "..\include\xapi_m.h"
#include "..\include\hdlc.h"
#include "..\include\rcode.h"
#include "..\include\DebugOut.h"

#define	ADDTEXT(x)	strcat(s, x)
#define	FORMHEX(x)	sprintf(t, "0x%02X", (BYTE)x)
#define	ADDHEX()	strcat(s, t)
#define	FORMBNUMBER(x)	sprintf(t, "%u", (BYTE)x)
#define	ADDNUMBER()	strcat(s, t)
#define	FORMWNUMBER(x)	sprintf(t, "%u", (WORD)x)

//???????????????
//#define	ADDUTEXT(x)	strcat(s, strupr(x))
//Original definition causing access violation 
//instead all the strings will be in upper case from the begining. -D-
#define	ADDUTEXT(x)	strcat(s, x)

char *unnumbered_frame_type[] = {
"SABM command", "DISC command", "DM response", "UI", "XID"
};

extern BYTE view_in_ascii;

void DecodeReturnCode(CBLOCK *cb, char *s);
void DumpAsyncData(CBLOCK *cb, char *s);

void DecodeReturnCode(CBLOCK *cb, char *s)
{
	BYTE rcode, pt;
	char t[100];

	rcode = (BYTE)cb->return_code;
	sprintf(s, "(0x%02X) ", rcode);

	switch(rcode) {
	case HDLC_LINK_CLOSED:
		ADDTEXT("The link is CLOSED");
		break;

	case E_INVALID_COMMAND:
		ADDTEXT("Invalid command: ");
		FORMHEX(cb->command); ADDHEX();
		break;

	case RN_UNNUMBERED_FRAME:
		ADDTEXT(unnumbered_frame_type[cb->data[0]-1]);
		ADDTEXT(" frame was received");
		break;

	case S_N2_RETRY_EXCEEDED:
		ADDTEXT("N2 Retry Limit Exceeded for the command: ");
		switch(cb->data[0]) {
		case 0x01:	ADDTEXT("SABM"); break;
		case 0x02:	ADDTEXT("DISC"); break;
		default:	ADDTEXT("UNKNOWN"); break;
		}
		break;
		
	case S_FRAME_REJECT_MODE:
		ADDTEXT("The link is in Frame Reject (FRMR) Mode:\nSource: ");
		ADDTEXT((cb->data[0] == 0x01) ? "Local" : "Remote");
		ADDTEXT("\nReason: ");
		switch(cb->data[1]) {
		case 0x01: ADDTEXT("Control field invalid or not implemented"); break;
		case 0x03: ADDTEXT("S or U frame received with an illegal I-field attached"); break;
		case 0x04: ADDTEXT("I-frame received whose data length exceeded the defined maximum"); break;
		case 0x08: ADDTEXT("Invalid NR count"); break;
		}
		ADDTEXT("\nFRMR Information field: ");
		FORMHEX(cb->data[2]); ADDHEX();
		FORMHEX(cb->data[3]); ADDHEX();
		FORMHEX(cb->data[4]); ADDHEX();
		FORMHEX(cb->data[5]); ADDHEX();
		break;

	case S_MODEM_FAILURE:
		ADDTEXT("Modem failure -");
		if (cb->data[0] & 0x01) ADDTEXT(" DCD low");
		if (cb->data[0] & 0x02) ADDTEXT(" CTS low");
		break;

	case S_Z80_TIMEOUT:
		ADDTEXT("Z80 timeout occurred (hardware failure)");
		break;

	case RN_ASYNC_PACKET:
		ADDTEXT("Asynchronous X.25 packet received on LCN ");
		FORMWNUMBER(cb->logical_channel); ADDNUMBER();
		ADDTEXT(", QD: ");
		FORMBNUMBER((cb->Q_D_M_bits & MASK_QBIT) ? 1 : 0); ADDNUMBER();
		FORMBNUMBER((cb->Q_D_M_bits & MASK_DBIT) ? 1 : 0); ADDNUMBER();
		ADDTEXT(" Cause: ");
		FORMHEX(cb->cause); ADDHEX();
		ADDTEXT(" Diag: ");
		FORMHEX(cb->diagnostic); ADDHEX();
		ADDTEXT("\nAsync. packet type: ");
		pt = (BYTE)cb->X25_packet_type;
		switch(pt & (BYTE)(AUTO_RESPONSE_FLAG ^ 0xff)) {
		case ASE_CLEAR_RQST: ADDUTEXT("CLEAR REQUEST/INDICATION"); break;
		case ASE_RESET_RQST: ADDUTEXT("RESET REQUEST/INDICATION"); break;
		case ASE_RESTART_RQST: ADDUTEXT("RESTART REQUEST/INDICATION"); break;
		case ASE_INTERRUPT: ADDUTEXT("INTERRUPT"); break;
		case ASE_DTE_REGISTR_RQST: ADDUTEXT("DTE REGISTRATION REQUEST"); break;
		case ASE_CALL_RQST: ADDUTEXT("CALL REQUEST/INCOMING CALL"); break;
		case ASE_CALL_ACCEPTED: ADDUTEXT("CALL ACCEPTED/CONNECTED"); break;
		case ASE_CLEAR_CONFRM: ADDUTEXT("CLEAR CONFIRMATION"); break;
		case ASE_RESET_CONFRM: ADDUTEXT("RESET CONFIRMATION"); break;
		case ASE_RESTART_CONFRM: ADDUTEXT("RESTART CONFIRMATION"); break;
		case ASE_INTERRUPT_CONFRM: ADDUTEXT("INTERRUPT CONFIRMATION"); break;
		case ASE_DCE_REGISTR_CONFRM: ADDUTEXT("DCE REGISTRATION CONFIRMATION"); break;
		case ASE_DIAGNOSTIC: ADDUTEXT("DIAGNOSTIC"); break;
		case ASE_CALL_AUTO_CLEAR: ADDUTEXT("CALL REQUEST/INCOMING CALL - CALL CLEARED"); break;
		default: FORMHEX(pt); ADDHEX(); break;
		}
		if (pt & (BYTE)AUTO_RESPONSE_FLAG)
			ADDTEXT(" [Responded Automatically]");
		if (cb->buffer_length > 0)  DumpAsyncData(cb, s);
		break;

	case S_PROTOCOL_VIOLATION:
		ADDTEXT("Protocol violation on LCN ");
		FORMWNUMBER(cb->logical_channel); ADDNUMBER();
		ADDTEXT(", QD: ");
		FORMBNUMBER((cb->Q_D_M_bits & MASK_QBIT) ? 1 : 0); ADDNUMBER();
		FORMBNUMBER((cb->Q_D_M_bits & MASK_DBIT) ? 1 : 0); ADDNUMBER();
		ADDTEXT(" Cause: ");
		FORMHEX(cb->cause); ADDHEX();
		ADDTEXT(" Diag: ");
		FORMHEX(cb->diagnostic); ADDHEX();
		ADDTEXT("\nTransmitted packet type: ");
		pt = (BYTE)cb->X25_packet_type;
		switch(pt & (BYTE)AUTO_RESPONSE_NOTMASK) {
		case ASE_CLEAR_CONFRM: ADDUTEXT("CLEAR REQUEST/INDICATION"); break;
		case ASE_RESET_CONFRM: ADDUTEXT("RESET REQUEST/INDICATION"); break;
		case ASE_RESTART_CONFRM: ADDUTEXT("RESTART REQUEST/INDICATION"); break;
		case ASE_DIAGNOSTIC: ADDUTEXT("DIAGNOSTIC"); break;
		default: FORMHEX(pt); ADDHEX(); break;
		}
		if ((pt & (BYTE)AUTO_RESPONSE_FLAG) &&
			pt != (BYTE)(ASE_RESTART_RQST | AUTO_RESPONSE_FLAG))
			ADDTEXT(" [RESTART Issued Automatically]");
		if (cb->buffer_length > 0)  DumpAsyncData(cb, s);
		break;
	case S_TIMEOUT:
		ADDTEXT("Timeout on LCN ");
		FORMWNUMBER(cb->logical_channel); ADDNUMBER();
		ADDTEXT(" Cause: ");
		FORMHEX(cb->cause); ADDHEX();
		ADDTEXT(" Diag: ");
		FORMHEX(cb->diagnostic); ADDHEX();
		ADDTEXT("\nTransmitted packet type: ");
		pt = (BYTE)cb->X25_packet_type;
		switch(pt) {
		case TIMEOUT_CLEAR: ADDUTEXT("CLEAR REQUEST/INDICATION"); break;
		case TIMEOUT_RESET: ADDUTEXT("RESET REQUEST/INDICATION"); break;
		case TIMEOUT_RESTART: ADDUTEXT("RESTART REQUEST/INDICATION"); break;
		case TIMEOUT_CALL: ADDUTEXT("CALL REQUEST"); break;
		default: FORMHEX(pt); ADDHEX(); break;
		}
		if (cb->buffer_length > 0)  DumpAsyncData(cb, s);
		break;

	case S_RETRY:
		ADDTEXT("Retry limit exceeded on LCN ");
		FORMWNUMBER(cb->logical_channel); ADDNUMBER();
		ADDTEXT("\nTransmitted packet type: ");
		pt = (BYTE)cb->X25_packet_type;
		switch(pt) {
		case TIMEOUT_CLEAR: ADDUTEXT("CLEAR REQUEST/INDICATION"); break;
		case TIMEOUT_RESET: ADDUTEXT("RESET REQUEST/INDICATION"); break;
		case TIMEOUT_RESTART: ADDUTEXT("RESTART REQUEST/INDICATION"); break;
		case TIMEOUT_CALL: ADDUTEXT("CALL REQUEST"); break;
		default: FORMHEX(pt); ADDHEX(); break;
		}
		if (cb->buffer_length > 0)  DumpAsyncData(cb, s);
		break;


	case S_NOT_IN_ABM:
		ADDTEXT("The link is not in ABM");
		break;

	case S_ASYNC_BUFF_IN_USE:
		switch(cb->command) {
		case X25_WRITE:
			ADDTEXT("Packet window closed or no transmit buffers available");
			break;
		case X25_READ:
			ADDTEXT("No data is available on specified channel to read");
			break;
		default:
			ADDTEXT("Async. buffer in use: packet not issued");
			break;
		}
		break;

	case S_NET_OUT_OF_ORDER:
		ADDTEXT("Network out of order - no data may be transferred");
		break;

	case S_QUEUED_DATA:
		ADDTEXT(COMMONMSG_0x35);
		break;

/* END OF COMMON ERROR CODES */

	default:
		switch(cb->command) {
		case CONFIGURE_LINK:
			switch(rcode) {
			case 0:
				ADDTEXT("Using D");
				ADDTEXT((cb->data[0] == 0x01) ? "T" : "C");
				ADDTEXT("E frame level addressing");
				break;
			case 1:
				ADDTEXT("Invalid addressing mode selected");
				break;
			}
			break;
		case SET_GLOBAL_VARIABLES:
			switch(rcode) {
			case 0:
				ADDTEXT("DTR status has been changed successfully");
				break;
			}
			break;
		case HDLC_OPEN:
			switch(rcode) {
			case 0:
				ADDTEXT("The link is now OPEN");
				break;
			case 1:
				ADDTEXT("The link is already open");
				break;
			}
			break;
		case HDLC_CLOSE:
			switch(rcode) {
			case 0:
				ADDTEXT("The link is now CLOSED");
				break;
			}
			break;
		case LINK_SETUP:
			switch(rcode) {
			case 0:
				ADDTEXT("Initializing link and attempting to enter ABM...");
				break;
			}
			break;
		case LINK_DISCONNECT:
			switch(rcode) {
			case 0:
				ADDTEXT("The link has been DISCONNECTED");
				break;
			case 2:
				ADDTEXT("The link is not in ABM");
				break;
			}
			break;
		case PLACE_CALL:
			switch(rcode) {
			case 0:
				ADDTEXT("Call placed on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				break;
			case 0x02:
				ADDTEXT("The link is not in ABM");
				break;
			case 0x30:
				ADDTEXT("No SVC available to place call");
				break;
			case 0x32:
				ADDTEXT("Call arguments too long");
				break;
			case 0x33:
				ADDTEXT("Asynchronous buffer in use");
				break;
			case 0x38:
				ADDTEXT("D-bit is not supported");
				break;
			case 0x39:
				ADDTEXT("Facility is not supported");
				break;
			case 0x3a:
				ADDTEXT("No destination address (-d) specified");
				break;
			case 0x3b:
				ADDTEXT("User data (-u) must contain even number of bytes");
				break;
			}
			break;
		case ACCEPT_CALL:
			switch(rcode) {
			case 0:
				ADDTEXT("Call accepted on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				break;
			case 0x02:
				ADDTEXT("The link is not in ABM");
				break;
			case 0x31:
				ADDTEXT("No incoming call logged on this channel");
				break;
			case 0x32:
				ADDTEXT("Call accept arguments too long");
				break;
			case 0x33:
				ADDTEXT("Asynchronous buffer in use");
				break;
			case 0x34:
				ADDTEXT("Incoming call included Fast Select Facility");
				break;
			case 0x38:
				ADDTEXT("D-bit is not supported");
				break;
			case 0x39:
				ADDTEXT("Facility is not supported");
				break;
			case 0x3b:
				ADDTEXT("User data (-u) must contain even number of bytes");
				break;
			}
			break;
		case CLEAR_CALL:
			switch(rcode) {
			case 0:
				ADDTEXT("Call cleared on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				break;
			case 0x02:
				ADDTEXT("The link is not in ABM");
				break;
			case 0x30:
				ADDTEXT("Specified channel not configured as SVC");
				break;
			case 0x31:
				ADDTEXT(COMMONMSG_0x31);
				break;
			case 0x32:
				ADDTEXT("Call clear arguments too long");
				break;
			case 0x35:
				ADDTEXT(COMMONMSG_0x35);
				break;
			case 0x39:
				ADDTEXT("Facility is not supported");
				break;
			case 0x3b:
				ADDTEXT("User data (-u) must contain even number of bytes");
				break;
			}
			break;
		case RESET_LOGICAL_CHANNEL:
			switch(rcode) {
			case 0:
				ADDTEXT("Reset request transmitted on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				break;
			case 0x02:
				ADDTEXT("The link is not in ABM");
				break;
			case 0x30:
				ADDTEXT(COMMONMSG_0x30);
				break;
			case 0x31:
				ADDTEXT(COMMONMSG_0x31);
				break;
			case 0x35:
				ADDTEXT(COMMONMSG_0x35);
				break;
			}
			break;
		case RESTART:
			switch(rcode) {
			case 0:
				ADDTEXT("Restart request issued");
				break;
			}
			break;
		case X25_WRITE:
			switch(rcode) {
			case 0:
				ADDTEXT("Packet sent on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				break;
			case 0x30:
				ADDTEXT(COMMONMSG_0x30);
				break;
			case 0x31:
				ADDTEXT(COMMONMSG_0x31);
				break;
			case 0x32:
				ADDTEXT("Data length exceeds permitted maximum");
				break;
			}
			break;
		case X25_READ:
			switch(rcode) {
			case 0:
				ADDTEXT("Packet read on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				ADDTEXT(" (length : ");
				FORMWNUMBER(cb->buffer_length); ADDNUMBER();
				ADDTEXT(")");
				break;
			case 0x30:
				ADDTEXT(COMMONMSG_0x30);
				break;
			case 0x31:
				ADDTEXT(COMMONMSG_0x31);
				break;
			}
			break;
		case INTERRUPT:
			switch(rcode) {
			case 0:
				ADDTEXT("Interrupt packet sent on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				break;
			case 0x30:
				ADDTEXT(COMMONMSG_0x30);
				break;
			case 0x31:
				ADDTEXT(COMMONMSG_0x31);
				break;
			case 0x32:
				ADDTEXT("Interrupt data exceeds maximum length or none entered");
				break;
			}
			break;
		case CONFIRM_INTERRUPT:
			switch(rcode) {
			case 0:
				ADDTEXT("Interrupt confirmation sent on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				break;
			case 0x30:
				ADDTEXT(COMMONMSG_0x30);
				break;
			case 0x31:
				ADDTEXT("No interrupt packet was received to confirm");
				break;
			}
			break;
		case CONFIRM_CLEAR:
			switch(rcode) {
			case 0:
				ADDTEXT("Clear confirmation sent on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				break;
			case 0x30:
				ADDTEXT("Specified logical channel not configured as SVC");
				break;
			case 0x31:
				ADDTEXT("No clear request was received to confirm");
				break;
			case 0x32:
				ADDTEXT("Packet arguments are too long");
				break;
			}
			break;
		case CONFIRM_RESET:
			switch(rcode) {
			case 0:
				ADDTEXT("Reset confirmation sent on LCN ");
				FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				break;
			case 0x30:
				ADDTEXT(COMMONMSG_0x30);
				break;
			case 0x31:
				ADDTEXT("No reset request was received to confirm");
				break;
			}
			break;
		case CONFIRM_RESTART:
			switch(rcode) {
			case 0:
				ADDTEXT("Restart request sent");
				break;
			case 0x31:
				ADDTEXT("No restart request was received to confirm");
				break;

			}
			break;
		case FLUSH_X25_DATA_BUFFERS:
			switch(rcode) {
			case 0:
				if (cb->logical_channel == 0)
					ADDTEXT("Data buffers flushed for all logical channels");
				else {
					ADDTEXT("Data buffers flushed on LCN ");
					FORMWNUMBER(cb->logical_channel); ADDNUMBER();
				}
				break;
			case 0x30:
				ADDTEXT(COMMONMSG_0x30);
				break;
			}
			break;
		}
	}
}


void DumpAsyncData(CBLOCK *cb, char *s)
{
	char t[10];
	int n;

	ADDTEXT("\nData: ");
	for (n=0; n < cb->buffer_length; n++) {
		if (n > 10) { ADDTEXT("..."); break; }
		sprintf(t, "%c", cb->data[n]);
		ADDTEXT(t);
	}
}

/*
//Original
void DumpAsyncData(CBLOCK *cb, char *s)
{
	char t[10];
	int n;
#ifdef DEBG
	Debug1("DumpAsyncData()\n");
#endif

	ADDTEXT("\n>>> ");
	for (n=0; n < cb->buffer_length; n++) {
		if (n > 10) { ADDTEXT("..."); break; }
		sprintf(t, "%02X '%c' ", (BYTE)cb->data[n], cb->data[n]);
		ADDTEXT(t);
	}
}
*/
