/* XTEST.C - Test program for XAPI.DLL */
/* link to EXE */

#define	STRICT

/* define for targetting NT or Windows 2000 */

#define	MAKEFORNT

//for debug output
//#define DEBG

#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "resource.h"

#ifdef MAKEFORNT
#include "..\include\xapi32mc.h"
#else
#include "..\include\xapi_f.h"
#endif

#include "..\include\xapi_m.h"
#include "..\include\hdlc.h"
#include "..\include\DebugOut.h"


#define	SAYSTATE(x)	SetWindowText(exehwn, x)
#define	SAYNOSTATE()	SetWindowText(exehwn, szProgramHeader)

#define	MSG_POLL	0x4000
#define	IDM_ABOUT	0x1000
#define	NUM_BUTTONS	16
#define	COUNT_MAX	100

#define	CAF		7

#define	ADJUST(x)	((x*ca)/CAF)

HINSTANCE ghinstance;
HWND exehwn, bhwn[NUM_BUTTONS], lbhwn, cbhwn, quhwn, hdhwn;
char rewrite=0;

#ifdef MAKEFORNT
char *abouttitle = "About The XTESTer v1.2nt";
char *aboutstatement =
"XTEST for NT is Copyright (c) 2001 Sangoma Technologies Inc.\nJune 2001 release";
#else
char *abouttitle = "About The XTESTer v1.0";
char *aboutstatement =
"XTEST is Copyright (c) 1994-1995 Sangoma Technologies Inc.\nDecember 1995 release";
#endif

char *szClassName = "XTESTClass";
char *szTitleName = "The XTESTer";
char rcvd[80];
char szProgramHeader[40];

char *our_ini_file = "xtest.ini";
char *iniHardwareSection = "Hardware";
char *iniCardEntry = "default_card_number";
char *iniAskEntry = "ask_for_card_on_startup";

/* set aside a pretty big buffer for rcode to return text information
don't bother with dynamic allocation for a 1000 bytes...(!?) */
char result_text[1000];

//if data is to be sent in hex, save it first in this buffer
char tx_buffer[1024];

BYTE card = 0;
BYTE askonstartup = 0;
BYTE view_in_ascii = 1;
BYTE send_hex_data = 0;

CBLOCK cb, auxb;
unsigned long sent = 0;
LONG pause = 0;

BOOL quitting_so_do_not_poll = TRUE;

BYTE commands[] = { PLACE_CALL, ACCEPT_CALL, CLEAR_CALL, RESET_LOGICAL_CHANNEL, RESTART,
		 X25_WRITE, X25_WRITE, X25_READ, X25_READ, 0,
		 INTERRUPT, CONFIRM_INTERRUPT, CONFIRM_CLEAR,
		 CONFIRM_RESET, CONFIRM_RESTART, FLUSH_X25_DATA_BUFFERS };
BYTE command_type;
BYTE enableit[][7] = {
{ 1, 0, 0, 0, 0, 1, 0 },
{ 1, 1, 0, 0, 0, 1, 0 },
{ 1, 1, 1, 1, 0, 0, 0 },
{ 0, 1, 1, 1, 0, 0, 0 },
{ 0, 0, 1, 1, 0, 0, 0 },
{ 1, 1, 0, 0, 1, 1, 1 },
{ 0, 0, 0, 0, 0, 0, 0 },
{ 0, 1, 0, 0, 0, 0, 0 },
{ 0, 1, 0, 0, 0, 0, 0 },
{ 0, 1, 0, 0, 0, 0, 0 },
{ 1, 1, 0, 0, 0, 0, 0 },
{ 0, 1, 0, 0, 0, 0, 0 },
{ 1, 1, 1, 1, 0, 0, 0 },
{ 0, 1, 0, 0, 0, 0, 0 },
{ 0, 0, 0, 0, 0, 0, 0 },
{ 0, 1, 0, 0, 0, 0, 0 }
};

char *commtitles[] = {
"Place Call", "Accept Call", "Clear Call", "Reset Call", "Restart",
"Send", "Send Many", "Receive", "Rcv Many", "Bounce", "Interrupt",
"Conf Int", "Conf Clear", "Conf Reset", "Conf Restrt", "Flush"
};

char *wintitles[] = {
"Place Call", "Accept Call", "Clear Call", "Reset Call", "Restart",
"Send Packet", "Send Many Packets", "Receive Packet", "Receive Many Packets",
"Bounce Packets", "Send Interrupt Packet", "Confirm Interrupt",
"Confirm Clear", "Confirm Reset", "Confirm Restart", "Flush Data Buffers"
};

BOOL okflag;

UINT nsent, ntosend, manysize;
BOOL fdomanysend = FALSE;
BOOL domanyrcv = FALSE;
BOOL dobounce = FALSE;
BOOL dorfes = FALSE;
WORD manychannel;
WORD rmanychannel;
WORD brchannel, bschannel;

extern void DecodeReturnCode(CBLOCK *cb, char *s);

/* prototypes */
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow);

LRESULT CALLBACK  MainWndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam );
LRESULT CALLBACK  DataDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK  ManySendDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK  BounceDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
void CheckInABM(void);
void SayMsg(char far *m);
void sendsomething(void);
void DoPolling(void);
void bounce(void);
void DoDataDialog(BYTE op);
void DoCommand(void);
void AddStringListBox(char far *m);
void SayResult(void);
void DoManySend(void);
void DoManyRecv(void);
void copy_cb(CBLOCK *dest, CBLOCK *src);
LRESULT CALLBACK  SelCardDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
void SelCard(void);
LRESULT CALLBACK  HDLCDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
BOOL ParseCmdLineForCard(LPSTR lpszCmdLine);
BOOL FirstSelCard(void);

//////////////////////////////////
int ParseTextToHex(int l);
int IsValidString(int l);

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	MSG msg;
	BOOL fRetVal;
	WNDCLASS wndclass;   // Structure used to register Windows class.
	int title_height, ca;	// ca = character width adjustment
//	int frame_height;
	HMENU hmenu;
	char s[150];
//	int i;
	int wid;
	HDC hdc;
	TEXTMETRIC tm;

	hdc = GetDC(NULL);
	GetTextMetrics(hdc, &tm);
	ReleaseDC(NULL, hdc);
	ca = tm.tmAveCharWidth;
        title_height = GetSystemMetrics(SM_CYCAPTION);
        if (tm.tmHeight > title_height) title_height = tm.tmHeight;
/*
	title_height=GetSystemMetrics(SM_CYCAPTION);
	ca = CAF;
	if (title_height > 20)
		ca = ((title_height*CAF) / 20);
*/		
//	frame_height=GetSystemMetrics(SM_CYFRAME);
	ghinstance = hInstance;

	card = (BYTE)GetPrivateProfileInt(iniHardwareSection, iniCardEntry, 0, our_ini_file);
	askonstartup = (BYTE)GetPrivateProfileInt(iniHardwareSection, iniAskEntry, 0, our_ini_file);
	

	if (hPrevInstance == NULL) {

	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = MainWndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = ghinstance;
	wndclass.hIcon         = LoadIcon(ghinstance, "testprog");
	wndclass.hCursor       = LoadCursor( NULL, IDC_ARROW );
	wndclass.hbrBackground = (HBRUSH)GetStockObject( GRAY_BRUSH );
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = szClassName;

	if (!RegisterClass(&wndclass)) {
		return(0);
	}

	}	/* end hInstance test */

	exehwn = CreateWindow( szClassName,
				szTitleName,
				WS_OVERLAPPED | WS_MINIMIZE | WS_MINIMIZEBOX | WS_CAPTION | WS_SYSMENU | WS_BORDER,
				CW_USEDEFAULT,
				200,
				ADJUST(600),
				title_height*11+8,
				HWND_DESKTOP,
				NULL,
				ghinstance,
				NULL);

	if (!exehwn)  return(0);

	wid = ADJUST(80);
	bhwn[0] = CreateWindow("BUTTON", commtitles[0], WS_CHILD | WS_VISIBLE, 2, 2, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[1] = CreateWindow("BUTTON", commtitles[1], WS_CHILD | WS_VISIBLE, wid+4, 2, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[2] = CreateWindow("BUTTON", commtitles[2], WS_CHILD | WS_VISIBLE, 2*wid+6, 2, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[3] = CreateWindow("BUTTON", commtitles[3], WS_CHILD | WS_VISIBLE, 3*wid+8, 2, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[4] = CreateWindow("BUTTON", commtitles[4], WS_CHILD | WS_VISIBLE, 4*wid+10, 2, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[5] = CreateWindow("BUTTON", commtitles[5], WS_CHILD | WS_VISIBLE, 2, title_height*2+6, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[6] = CreateWindow("BUTTON", commtitles[6], WS_CHILD | WS_VISIBLE, wid+4, title_height*2+6, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[7] = CreateWindow("BUTTON", commtitles[7], WS_CHILD | WS_VISIBLE, 2*wid+6, title_height*2+6, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[8] = CreateWindow("BUTTON", commtitles[8], WS_CHILD | WS_VISIBLE, 3*wid+8, title_height*2+6, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[9] = CreateWindow("BUTTON", commtitles[9], WS_CHILD | WS_VISIBLE, 4*wid+10, title_height*2+6, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[10] = CreateWindow("BUTTON", commtitles[10], WS_CHILD | WS_VISIBLE, 2, title_height+4, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[11] = CreateWindow("BUTTON", commtitles[11], WS_CHILD | WS_VISIBLE, wid+4, title_height+4, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[12] = CreateWindow("BUTTON", commtitles[12], WS_CHILD | WS_VISIBLE, 2*wid+6, title_height+4, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[13] = CreateWindow("BUTTON", commtitles[13], WS_CHILD | WS_VISIBLE, 3*wid+8, title_height+4, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[14] = CreateWindow("BUTTON", commtitles[14], WS_CHILD | WS_VISIBLE, 4*wid+10, title_height+4, wid, title_height, exehwn, NULL, ghinstance, NULL);
	bhwn[15] = CreateWindow("BUTTON", commtitles[15], WS_CHILD | WS_VISIBLE, 5*wid+12, 2, wid, title_height, exehwn, NULL, ghinstance, NULL);
	cbhwn   = CreateWindow("BUTTON", "Card Select", WS_CHILD | WS_VISIBLE, ADJUST(596)-wid, 2, wid, title_height, exehwn, NULL, ghinstance, NULL);
	quhwn   = CreateWindow("BUTTON", "Quit", WS_CHILD | WS_VISIBLE, ADJUST(596)-wid, title_height*2+6, wid, title_height, exehwn, NULL, ghinstance, NULL);
	hdhwn   = CreateWindow("BUTTON", "HDLC...", WS_CHILD | WS_VISIBLE, ADJUST(596)-wid, title_height+4, wid, title_height, exehwn, NULL, ghinstance, NULL);
	lbhwn = CreateWindow("LISTBOX", "", WS_CHILD | WS_VISIBLE | WS_VSCROLL | LBS_DISABLENOSCROLL, 1, title_height*3+9, ADJUST(596),
				 title_height*7, exehwn, NULL, ghinstance, NULL);

	ShowWindow(exehwn, cmdShow);
	UpdateWindow(exehwn);

	if (!ParseCmdLineForCard(lpszCmdLine)) {
                if (askonstartup) {
                        if (!FirstSelCard()) {
                                DestroyWindow(exehwn);
                                return(0);
                        }
                }
	}

	if (!XAPIRegisterCard(card)) {
		sprintf(s, "Unable to register card %u!  XTEST will now terminate. Check the card is loaded and check cable connections.  (Default card number may be changed by editing XTEST.INI.)", card);
		MessageBox(exehwn, s, "XTEST FATAL ERROR", MB_OK | MB_ICONHAND);
		DestroyWindow(exehwn);
		return(0);
	}

	hmenu = GetSystemMenu(exehwn, FALSE);
	AppendMenu(hmenu, MF_SEPARATOR, 0, (LPSTR) NULL);
	AppendMenu(hmenu, MF_STRING, IDM_ABOUT, "About...");

	sprintf(szProgramHeader, "%s (Card %u)", szTitleName, card);
	SAYNOSTATE();

	CheckInABM();

	quitting_so_do_not_poll = FALSE;
	fRetVal = TRUE;
	while (fRetVal)  {
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {

			if (msg.message == WM_QUIT)
				fRetVal = FALSE;

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		/* EXTREMELY IMPORTANT that you do not poll when the
		application does not have a card registered! */
		if (!quitting_so_do_not_poll)  DoPolling();
	}
	return fRetVal;


//	return(msg.wParam);
}

BOOL ParseCmdLineForCard(LPSTR lpszCmdLine)
{
	int i;
	BYTE c;

	i=0;
	while (lpszCmdLine[i] != NULL && lpszCmdLine[i] != '-') i++;
	if (lpszCmdLine[i] == '-') {
		c = (BYTE)atoi((LPSTR)(lpszCmdLine+i+1));
		if (c < 16) {
			card = c;
			return(TRUE);
		}
	}
	return(FALSE);
}

void AddStringListBox(char far *m)
{
	static UINT count = 0;

	count++;
	if (count == COUNT_MAX)  {
		SendMessage(lbhwn, LB_DELETESTRING, 0, 0L);
		count--;
	}
	SendMessage(lbhwn, LB_ADDSTRING, 0, (LPARAM)m);
	SendMessage(lbhwn, LB_SETCURSEL, count-1, 0L);
}

void SayResult(void)
{
	int i, start;
	
	DecodeReturnCode(&cb, (char *)&result_text[0]);

	start=0; i=0;
	while (result_text[i] != '\0') {
		if (result_text[i] == '\n') {
			result_text[i] = '\0';
			AddStringListBox(result_text+start);
			start=i+1;
		}
		i++;
	}
	AddStringListBox(result_text+start);

	if(cb.command != X25_READ)
		AddStringListBox(":");
}

LRESULT CALLBACK  MainWndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam )
{
//	MSG msg;
	HWND h;
//	static unsigned long poll_count = 0;
//	char s[80];
	int i;
	DLGPROC dproc;

	switch(iMessage) {
	case WM_CREATE:
//		XAPIAlive();
		XAPISetup();
		return(0);
	case WM_DESTROY:
		quitting_so_do_not_poll = TRUE;
		XAPIDeregisterCard(card);
		XAPICleanup();
		PostQuitMessage(0);
		break;
	case WM_COMMAND:
		h = GET_WM_COMMAND_HWND(wParam, lParam);
		if (h == cbhwn) {
			SelCard();
		} else if (h == quhwn) {
			PostMessage(hWnd, WM_CLOSE, 0, 0L);
		} else if (h == hdhwn) {
			dproc = (DLGPROC)MakeProcInstance((FARPROC)HDLCDlg, ghinstance);
			DialogBox(ghinstance, "HDLC", exehwn, dproc);
			FreeProcInstance((FARPROC)dproc);
		} else {
			for (i=0; i < NUM_BUTTONS; i++)
				if (h == bhwn[i]) { DoDataDialog(i); break; }
		}
		return(0);
	case WM_SYSCOMMAND:
		if (GET_WM_COMMAND_ID(wParam, lParam) == IDM_ABOUT)
			MessageBox(exehwn, aboutstatement, abouttitle, MB_OK | MB_ICONINFORMATION);
		return DefWindowProc( hWnd, iMessage, wParam, lParam );
	default:
		return DefWindowProc( hWnd, iMessage, wParam, lParam );
	}
	return(1);
}

BOOL FirstSelCard(void)
{
	DLGPROC dproc;
	int i;

	dproc = (DLGPROC)MakeProcInstance((FARPROC)SelCardDlg, ghinstance);
	i=DialogBox(ghinstance, "SELCARD", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
        if (i) {
                card = i-1;
                return(TRUE);
        }
        return(FALSE);
}

void SelCard(void)
{
	DLGPROC dproc;
	int i;
//	char s[80];

	dproc = (DLGPROC)MakeProcInstance((FARPROC)SelCardDlg, ghinstance);
	i=DialogBox(ghinstance, "SELCARD", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
	if (i) {
		if (XAPIRegisterCard(i-1)) {
			XAPIDeregisterCard(card);
			card = i-1;
			sprintf(szProgramHeader, "%s (Card %u)", szTitleName, card);
			SAYNOSTATE();
		}
		else {
			MessageBox(exehwn, "Unable to register specified card!", "XTEST FATAL ERROR", MB_OK | MB_ICONHAND);
		}
	}
}

void DoDataDialog(BYTE op)
{
	DLGPROC dproc;
	int i;
	char s[80];

	cb.command = commands[op];
	command_type = op;

	if (op == 8 && domanyrcv) {
		domanyrcv = FALSE;
		for (i=0; i < NUM_BUTTONS; i++)
			if (i != 8) EnableWindow(bhwn[i], TRUE);
		SetWindowText(bhwn[8], commtitles[8]);
		SAYNOSTATE();
		return;
	}
	if (op == 9 && dobounce) {
		dobounce = FALSE;
		for (i=0; i < NUM_BUTTONS; i++)
			if (i != 9) EnableWindow(bhwn[i], TRUE);
		SetWindowText(bhwn[9], commtitles[9]);
		SAYNOSTATE();
		return;
	}
	if (op == 6) {
		if (fdomanysend) {
			fdomanysend = FALSE;
			for (i=0; i < NUM_BUTTONS; i++)
				if (i != 6) EnableWindow(bhwn[i], TRUE);
			SetWindowText(bhwn[6], commtitles[6]);
			SAYNOSTATE();
			return;
		}

		dproc = (DLGPROC)MakeProcInstance((FARPROC)ManySendDlg, ghinstance);
		i=DialogBox(ghinstance, "MANYSEND", exehwn, dproc);
		FreeProcInstance((FARPROC)dproc);
		if (i) {
			for (i=0; i < NUM_BUTTONS; i++)
				if (i != 6) EnableWindow(bhwn[i], FALSE);
			SetWindowText(bhwn[6], "STOP!");
			sprintf(s, "Multiple Send %son LCN %u (Card %u)", (dorfes) ? "and Receive " : "", manychannel, card);
			SAYSTATE(s);
		}
	}
	else if (op == 9) {
		dproc = (DLGPROC)MakeProcInstance((FARPROC)BounceDlg, ghinstance);
		i=DialogBox(ghinstance, "BOUNCE", exehwn, dproc);
		FreeProcInstance((FARPROC)dproc);
		if (i > 0) {
			for (i=0; i < NUM_BUTTONS; i++)
				if (i != 9) EnableWindow(bhwn[i], FALSE);
			SetWindowText(bhwn[9], "STOP!");
			dobounce = TRUE;
			sprintf(s, "Bounce from LCN %u to LCN %u (Card %u)", brchannel, bschannel, card);
			SAYSTATE(s);
		}
	} else {
		dproc = (DLGPROC)MakeProcInstance((FARPROC)DataDlg, ghinstance);
		i=DialogBox(ghinstance, "DENTRY", exehwn, dproc);

#ifdef DEBG
		Debug2("********DataDlg returns : %d\n", i);
#endif

		FreeProcInstance((FARPROC)dproc);
		if (i > 0) {
			if (op == 8) {
				for (i=0; i < NUM_BUTTONS; i++)
					if (i != 8) EnableWindow(bhwn[i], FALSE);
				SetWindowText(bhwn[8], "STOP!");
				domanyrcv = TRUE;
				rmanychannel = cb.logical_channel;
				sprintf(s, "Multiple Receive on LCN %u (Card %u)", rmanychannel, card);
				SAYSTATE(s);
			} else DoCommand();
		}
	}
}


void DoCommand(void)
{
	BYTE result;
	char s[100], t[10];
	UINT n;

	result = (BYTE)XAPIControl(&cb, card);

	SayResult();

	if (result == 0 && cb.command == X25_READ) {
		sprintf(s, "Data: ");
		for (n=0; n < cb.buffer_length; n++) {
			if (n > 10) { strcat(s, "..."); break; }

			if(view_in_ascii)
				sprintf(t, "%c", cb.data[n]);
			else
				sprintf(t, "%02X", (BYTE)cb.data[n]);

			strcat(s, t);
		}
		AddStringListBox(s);
		AddStringListBox(":");
	}else if(result != 0 && cb.command == X25_READ){
		AddStringListBox(":");
	}
}


/*
//Original
void DoCommand(void)
{
	BYTE result;
	char s[100], t[10];
	UINT n;

	result = (BYTE)XAPIControl(&cb, card);

//	if (cb.command == RESTART)  {
//		pause = 1;
//		pause = 100000L;
//	}


	if (result == 0 && cb.command == X25_READ) {
		sprintf(s, ">>> ");
		for (n=0; n < cb.buffer_length; n++) {
			if (n > 10) { strcat(s, "..."); break; }
			sprintf(t, "%02X '%c' ", (BYTE)cb.data[n], cb.data[n]);
			strcat(s, t);
		}
		AddStringListBox(s);
	}
	SayResult();
}
*/


void DoPolling(void)
{
	static unsigned long poll_count = 0;
//	char s[80];

	if (pause > 0) { pause--; return; }

	pause = 1;

	poll_count++;
/*
	if (poll_count % 1000L == 0L)  {
		sprintf(s, "Poll: %lu, Sent: %lu", poll_count, sent);
		SayMsg(s);
	}
*/
/*
	if (rewrite)  {
		if (XAPIControl(&cb) == 0x33)  rewrite=1;
		else { rewrite=0; sent++; }
	}
	else if (XAPIDataToRead(1)) {
		bounce();
	}
*/
	/* see if any async things to report */
	if (XAPIqNotification(card)) {
		cb.command = IS_DATA_AVAILABLE;
		cb.buffer_length = 0;
		cb.logical_channel = 0;
		DoCommand();
	}

	if (fdomanysend) DoManySend();
	if (domanyrcv) DoManyRecv();
	if (dobounce) bounce();
}

void DoManyRecv(void)
{
	if (XAPIqDataToRead(rmanychannel, card)) {
		cb.logical_channel = rmanychannel;
		cb.command = X25_READ;
		cb.buffer_length = 0;
		DoCommand();
	}
}

void DoManySend(void)
{
	UINT n, i;

	cb.buffer_length = manysize;
	cb.command = X25_WRITE;
	cb.logical_channel = manychannel;
	for (n=0; n < manysize; n++)
		cb.data[n] = (BYTE)(nsent % 0x100);
	if (!XAPIControl(&cb, card)) {
		nsent++;
		if (ntosend > 0 && nsent >= ntosend)  {
			for (i=0; i < NUM_BUTTONS; i++)
				if (i != 6) EnableWindow(bhwn[i], TRUE);
			SetWindowText(bhwn[6], commtitles[6]);
			SAYNOSTATE();
			fdomanysend = FALSE;
		}
	}
	SayResult();
	if (dorfes) DoManyRecv();
}

void bounce(void)
{
	if (rewrite) {
		copy_cb(&cb, &auxb);
		DoCommand();
		if (cb.return_code == 0) {
			rewrite=0; sent++;
		} else return;
	}

	if (!XAPIqDataToRead(brchannel, card)) return;

	cb.command = X25_READ;
	cb.logical_channel = brchannel;
	cb.buffer_length=0;
	DoCommand();
	if (cb.return_code == 0) {
		cb.command = X25_WRITE;
		cb.logical_channel = bschannel;
		DoCommand();
		if (cb.return_code != 0) {
			rewrite=1;
			copy_cb(&auxb, &cb);
		}
		else { rewrite=0; sent++; }
	}
}

void copy_cb(CBLOCK *dest, CBLOCK *src)
{
	memcpy((void *)dest, (void *)src, sizeof(CBLOCK));
}

void CheckInABM(void)
{
	char s[80];

	sprintf(s, "Link in ABM: %s", (XAPIqLinkInABM(card)) ? "YES" : "NO");
	AddStringListBox(s);
}
/*
void sendsomething(void)
{
	cb.command = X25_WRITE;
	cb.logical_channel = 1;
	strcpy(cb.data, rcvd);
	cb.buffer_length=strlen(rcvd);
	XAPIControl(&cb, card);
	cb.command = X25_READ;
	if (!XAPIControl(&cb, card)) {
		cb.data[cb.buffer_length]=0;
		SayMsg(cb.data);
		strcpy(rcvd, cb.data);
	} else  SayMsg("Nothing to receive after send.");
}
*/

LRESULT CALLBACK  DataDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	char s[80];
	int n;
	static WORD lc;
	char qdm;

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:	/* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
#ifdef DEBG
		Debug2("command_type : 0x%x\n", command_type);
#endif

		strcpy(s, wintitles[command_type]);
		strcat(s, " Transaction Data");
		SetWindowText(hDlg, s);
		for (n=0; n < 7; n++) {
			EnableWindow(GetDlgItem(hDlg, 101+n), enableit[command_type][n]);
			if (n < 4) EnableWindow(GetDlgItem(hDlg, 201+n), enableit[command_type][n]);
		}
		SetDlgItemInt(hDlg, 102, lc, FALSE);

		//if this is Send enable SEND_HEX_DATA check box.
		if(command_type == 0x5)
		{	EnableWindow(GetDlgItem(hDlg, SEND_HEX_DATA), TRUE);
			if(send_hex_data)
				CheckDlgButton(hDlg,  SEND_HEX_DATA,  BST_CHECKED);
		}

		//if this is Receive or Receive Many enable VIEW_IN_ASCII check box.
		if(command_type == 0x7 || command_type == 0x08)
		{	EnableWindow(GetDlgItem(hDlg, VIEW_IN_ASCII), TRUE);
			if(view_in_ascii)
				CheckDlgButton(hDlg,  VIEW_IN_ASCII,  BST_CHECKED);
		}


		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case IDOK:
			n=GetDlgItemText(hDlg, 101, cb.data, 1024);
			cb.logical_channel = GetDlgItemInt(hDlg, 102, NULL, FALSE);
			cb.cause = (BYTE)GetDlgItemInt(hDlg, 103, NULL, FALSE);
			cb.diagnostic = (BYTE)GetDlgItemInt(hDlg, 104, NULL, FALSE);
			cb.buffer_length = n;
			qdm = 0;
			if (IsDlgButtonChecked(hDlg, 105)) qdm |= MASK_QBIT;
			if (IsDlgButtonChecked(hDlg, 106)) qdm |= MASK_DBIT;
			if (IsDlgButtonChecked(hDlg, 107)) qdm |= MASK_MBIT;
			cb.Q_D_M_bits = qdm;
			lc = cb.logical_channel;

			//this is for viewing the data in different formats
			if (IsDlgButtonChecked(hDlg, VIEW_IN_ASCII)) view_in_ascii = 1;
			else	view_in_ascii = 0;

			if (IsDlgButtonChecked(hDlg, SEND_HEX_DATA))
			{	int ind = 0;
				//set to one, so next time the box is opened it's checked
				send_hex_data = 1;

				//if data is to be sent in hex, save it first in 'tx_buffer',
				//parce it, and then copy to the control block buffer
				n=GetDlgItemText(hDlg, 101, tx_buffer, 1024);
#ifdef DEBG
				Debug2("read %d bytes\n", n);
				Debug2("%s\n", tx_buffer);
#endif
				//parse the string
				n=ParseTextToHex(n);
				if(n == 0)
				{	//parsing errors - put message and refuse to send
					//MessageBox(exehwn, s, "Open Error", MB_OK | MB_ICONEXCLAMATION);
					//MessageBox(hDlg, s, "Invalid Input. ", MB_OK | MB_ICONEXCLAMATION);
					break;
				}else
					cb.buffer_length = n;
#ifdef DEBG
				for(ind = 0; ind < cb.buffer_length ; ind++)
					Debug3("cb.data[%d] = 0x%x\n", ind, cb.data[ind]);
#endif
			}
			
			EndDialog(hDlg, 1);
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		}
	}
	return(0);
}

/*
int ParseTextToHex(int l)
{
	int i, j;
	DWORD v = 0;

	i=0; j=0;
	while (i < l) {
		sscanf(&tx_buffer[i], "%2lx", &v);
		cb.data[j] = (BYTE)v;
		v = 0;
		j++;
		while (i < l && tx_buffer[i] != ' ') i++;
		i++;
	}
	return(j);
}
*/

int ParseTextToHex(int l)
{
	int i, j;
	DWORD v = 0;

	if(!IsValidString(l))
		return 0;

	i=0; j=0;
	while (i < l) {
		sscanf(&tx_buffer[i], "%2lx", &v);
		cb.data[j] = (BYTE)v;
		v = 0;
		j++;
		//move to next two
		i+=2;
	}

#ifdef DEBG
	Debug2(" j : %d\n", j);
#endif

	return(j);
}

int IsValidString(int l)
{
	int i = 0;
	UCHAR tmp = 0;

	strupr(tx_buffer);

#ifdef DEBG
	Debug2("IsValidString() : %s\n", tx_buffer);
#endif

	if((l < 2) || (l % 2))
	{	MessageBox(exehwn, "Number of characters in data string is not even.", 
										"Invalid Input", MB_OK | MB_ICONEXCLAMATION);
		return 0;
	}

	while(i < l)
	{	tmp = tx_buffer[i];

		//check it's alphanumeric char
		if(!isalnum(tmp) )
		{	MessageBox(exehwn, "Not an alphanumeric character in data string.", 
										"Invalid Input", MB_OK | MB_ICONEXCLAMATION);
			return 0;
		}

		//check it's digit
		if(	!isdigit(tmp))
		{	//check it's a hex digit
			if(tmp < 'A' || tmp > 'F')
			{	MessageBox(exehwn, "Not a hex digit in data string.",
										"Invalid Input", MB_OK | MB_ICONEXCLAMATION);
				return 0;
			}
		}
		i++;
	}

	//passed all checks
	return 1;
}


LRESULT CALLBACK  ManySendDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	char qdm;

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:	/* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		SetDlgItemInt(hDlg, 103, ntosend, FALSE);
		SetDlgItemInt(hDlg, 102, manychannel, FALSE);
		SetDlgItemInt(hDlg, 104, manysize, FALSE);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case IDOK:
			manychannel = (WORD)GetDlgItemInt(hDlg, 102, NULL, FALSE);
			ntosend = (UINT)GetDlgItemInt(hDlg, 103, NULL, FALSE);
			manysize = (UINT)GetDlgItemInt(hDlg, 104, NULL, FALSE);
			qdm = 0;
			if (IsDlgButtonChecked(hDlg, 105)) qdm |= MASK_QBIT;
			if (IsDlgButtonChecked(hDlg, 106)) qdm |= MASK_DBIT;
			if (IsDlgButtonChecked(hDlg, 107)) qdm |= MASK_MBIT;
			cb.Q_D_M_bits = qdm;
			if (IsDlgButtonChecked(hDlg, 108)) {
				dorfes = TRUE;
				rmanychannel = manychannel;
			} else dorfes = FALSE;

			fdomanysend = TRUE;
			nsent = 0;
			EndDialog(hDlg, 1);
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		}
	}
	return(0);
}

LRESULT CALLBACK  BounceDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:	/* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		SetDlgItemInt(hDlg, 103, bschannel, FALSE);
		SetDlgItemInt(hDlg, 102, brchannel, FALSE);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case IDOK:
			brchannel = (WORD)GetDlgItemInt(hDlg, 102, NULL, FALSE);
			bschannel = (UINT)GetDlgItemInt(hDlg, 103, NULL, FALSE);
			EndDialog(hDlg, 1);
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		}
	}
	return(0);
}

LRESULT CALLBACK  SelCardDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	int n, m, default_card;
	LRESULT c;
	char s[5];
	static int ncard;

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:	/* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		c = XAPIGetCards(); m = 0;
		ncard = (int)card;
		for (n=0; n < 16; n++) {
			if (c & (1L << (16+n))) {
				sprintf(s, "%2d", n);
				SendDlgItemMessage(hDlg, 101, CB_ADDSTRING, 0, (LPARAM)s);
				if (ncard == n)
					SendDlgItemMessage(hDlg, 101, CB_SETCURSEL, m, 0);
				m++;
			}
		}
		default_card = GetPrivateProfileInt(iniHardwareSection, iniCardEntry, 0, our_ini_file);
		sprintf(s, "%u", (UINT)default_card);
		SetDlgItemText(hDlg, 103, s);
		CheckDlgButton(hDlg, 104, askonstartup);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 101:
			if (GET_WM_COMMAND_CMD(wParam, lParam) == CBN_SELENDOK) {
				SendDlgItemMessage(hDlg, 101, CB_GETLBTEXT, (WPARAM)SendDlgItemMessage(hDlg, 101, CB_GETCURSEL, 0, 0), (LPARAM)s);
				ncard = atoi(s);
			}
			break;
		case IDOK:
			if (IsDlgButtonChecked(hDlg, 102)) {
				sprintf(s, "%u", (UINT)ncard);
				WritePrivateProfileString(iniHardwareSection, iniCardEntry, s, our_ini_file);
			}
			if (IsDlgButtonChecked(hDlg, 104)) strcpy(s, "1");
			else strcpy(s, "0");
			if (askonstartup != (s[0]-'0'))  {
				WritePrivateProfileString(iniHardwareSection, iniAskEntry, s, our_ini_file);
				askonstartup = (s[0]-'0');
			}
			EndDialog(hDlg, ncard+1);
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		}
	}
	return(0);
}



LRESULT CALLBACK  HDLCDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	BOOL e;

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:	/* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		cb.buffer_length = 0;
		cb.logical_channel = 0;
		return(1L);
	case WM_COMMAND:
		e=FALSE;
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 2:	// open
			cb.command = HDLC_OPEN;
			e=TRUE;
			break;
		case 3:	// close
			cb.command = HDLC_CLOSE;
			e=TRUE;
			break;
		case 4:	// setup
			cb.command = LINK_SETUP;
			e=TRUE;
			break;
		case 5:	// disconnect
			cb.command = LINK_DISCONNECT;
			e=TRUE;
			break;
		case 20:	// dte
			cb.command = CONFIGURE_LINK;
			cb.data[0] = 0x01;
			cb.buffer_length = 1;
			e=TRUE;
			break;
		case 21:	// dce
			cb.command = CONFIGURE_LINK;
			cb.data[0] = 0x02;
			cb.buffer_length = 1;
			e=TRUE;
			break;
		case 10:
			EndDialog(hDlg, 0);
			break;
		case 11:	// raise DTR
			cb.command = SET_GLOBAL_VARIABLES;
			cb.data[0] = 0x00;
			cb.data[1] = 0x02;
			cb.data[2] = 0x00;
			cb.buffer_length = 3;
			e=TRUE;
			break;
		case 12:	// lower DTR
			cb.command = SET_GLOBAL_VARIABLES;
			cb.data[0] = 0x00;
			cb.data[1] = 0x01;
			cb.data[2] = 0x00;
			cb.buffer_length = 3;
			e=TRUE;
			break;
		}
		if (e) {
			DoCommand();
			EndDialog(hDlg, 0);
		}
	}
	return(0);
}

