/*++
Copyright (c) 1994-2000 Sangoma Technologies Inc.
Module Name:
    sdla.h
Abstract:
--*/


#define	IOCTL_SDLA_DUMMY			CTL_CODE(FILE_DEVICE_UNKNOWN, 0, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define	IOCTL_SDLA_READ_BYTE		CTL_CODE(FILE_DEVICE_UNKNOWN, 10, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_WRITE_BYTE		CTL_CODE(FILE_DEVICE_UNKNOWN, 11, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_READ_PORT_BYTE	CTL_CODE(FILE_DEVICE_UNKNOWN, 12, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_WRITE_PORT_BYTE	CTL_CODE(FILE_DEVICE_UNKNOWN, 13, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_READ_BLOCK		CTL_CODE(FILE_DEVICE_UNKNOWN, 14, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_WRITE_BLOCK		CTL_CODE(FILE_DEVICE_UNKNOWN, 15, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_GET_CARDS		CTL_CODE(FILE_DEVICE_UNKNOWN, 20, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_REGISTER		    CTL_CODE(FILE_DEVICE_UNKNOWN, 21, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_DEREGISTER		CTL_CODE(FILE_DEVICE_UNKNOWN, 22, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_PREPARE_TO_LOAD	CTL_CODE(FILE_DEVICE_UNKNOWN, 23, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_LOAD_COMPLETE	CTL_CODE(FILE_DEVICE_UNKNOWN, 24, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_SDLA_ZERO_WINDOW		CTL_CODE(FILE_DEVICE_UNKNOWN, 25, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define	IOCTL_START_S514		    CTL_CODE(FILE_DEVICE_UNKNOWN, 26, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define	IOCTL_STOP_S514		        CTL_CODE(FILE_DEVICE_UNKNOWN, 27, METHOD_BUFFERED, FILE_ANY_ACCESS)

#pragma pack(1)
typedef struct {
	UCHAR cardnumber;
	ULONG offset;
	UCHAR value;
} XFER_BYTE_CONTROL;

#define	MAX_CARDS	16

/* structure used for reading and writing blocks */
typedef struct {
	void *buffer;
	USHORT num_bytes;
	ULONG offset;
	UCHAR card_number;
} SDLA_BLOCKOP;

typedef struct {
	UCHAR cardnumber;
	UCHAR rcode;
} CARD_TRANSACTION;
#pragma pack()

/*----- RESULT MESSAGES -----*/

#define	SDLAR_NOT_REGISTERED	0L
#define	SDLAR_DEREGISTERED		1L
#define	SDLAR_RELEASED			2L
#define	SDLAR_REGISTERED        1L
#define	SDLAR_ALLOCATED			2L

#define	SDLAR_CARD_BLOCKED		0L
#define	SDLAR_PREPARED			2L
#define	SDLAR_NOT_PREPARED		0L
#define	SDLAR_ERROR_PREPARING	3L
